package com.lwby.marketing.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.lwby.marketing.att.NovelAttributionMain;
import com.lwby.marketing.att.storynovel.UniversalStoryProcess;
import com.lwby.marketing.att.storynovel.media.IStoryCallback;
import com.lwby.marketing.att.storynovel.media.jrtt.JRTTActiveCallback;
import com.lwby.marketing.att.storynovel.media.jrtt.JRTTPayCallback;
import com.lwby.marketing.vo.StoryNovelAction;
import com.lwby.marketing.vo.StoreUserUploadEventBO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Map;
import java.util.function.Function;

/**
 * @author songxinyu
 * @version AttrController.java, v 0.1 2024年03月05日 17:30 songxinyu Exp $
 */

@RestController
@RequestMapping(value = "/attr")
public class AttrController {

    @Autowired
    NovelAttributionMain nm;

    @RequestMapping("/testUpload")
    public void testUpload() {
        String msg = "{\"clientInfo\":{\"channel\":214120503,\"clientIp\":\"183.219.7.180\",\"pkv\":1,\"platformGroupId\":412,"
                + "\"platformId\":412,\"sessionid\":\"undefined\",\"ua\":\"Mozilla/5.0 (Linux; Android 12; OXF-AN00 Build/HUAWEIOXF-AN00;"
                + " wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/117.0.0.0 Mobile Safari/537.36 aweme.lite/28.9.0 "
                + "ToutiaoMicroApp/3.14.0 PluginVersion/28909073\",\"version\":\"2.0.0\",\"xClient\":\"version=2.0.0;platformId=412;"
                + "equipment=android\"},\"createTime\":1709533439693,\"extraData\":{},\"id\":\"93857260-8130-442f-bc92-b549dbf28ef0\","
                + "\"userId\":875325,\"userUploadEvent\":2,\"productId\":\"1\",\"appId\":\"ttd3dda5604ce230b401\","
                + "\"openId\":\"_000HgDjWl-P5-WS9HTQIssNgTnMBRUqDHDu\"}";

        StoreUserUploadEventBO event = JSONObject.parseObject(msg, StoreUserUploadEventBO.class);
        StoryNovelAction action = new StoryNovelAction(event.getClientInfo(),event.getUserId(),event.getOpenId(),event.getUserUploadEvent(),
                event.getProductId());

        try {
            nm.executorStoryNovel.execute(action);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Resource
    UniversalStoryProcess up;

    @RequestMapping("dedu")
    public void testDedu() {
        Integer platformId = 601;
        Integer channelId = 2122123;
        String shaveMakeCall = up.getAttributeRuleByPlatformIdAndChannelId(platformId,channelId);
        if (StringUtils.isEmpty(shaveMakeCall)) {
            //直接回传,走回传流
            return;
        }
        /**
         * 金额扣量规则
         * 商品id  ： 回传
         * {
         *   "1" : 85,
         *   "2" : 90,
         *   "3" : 40,
         *   "4" : 100
         * }
         */

        Map<String, Integer> map = JSON.parseObject(shaveMakeCall, Map.class);

        Integer sprDedu = 0;
        String goodId = "1";

        for (Map.Entry<String, Integer> entry : map.entrySet()) {
            String key = entry.getKey();
            if (key.equals(goodId)) {
                sprDedu = entry.getValue();
                break;
            }
        }

        System.out.println(sprDedu);

        Function<Integer, IStoryCallback> function = new Function<Integer, IStoryCallback>() {
            @Override
            public IStoryCallback apply(Integer c) {
                return c == 0 ? new JRTTActiveCallback() : new JRTTPayCallback();
            }
        };
    }
}
